// project created on 06.08.2002 at 19:45
using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Drawing2D;


class MainForm : Form
{
	Timer timer1 = new Timer();	
	Image background = Image.FromFile("img/background.jpg");
	AnimSprite sprite = new AnimSprite("img/running_dog.gif", 60);	
	int x;	
	
	MainForm()
	{
		Text = "Sprite Animation";
		Size = new Size(400, 150);
		MaximizeBox = false;		
		FormBorderStyle = FormBorderStyle.FixedSingle;	
		CenterToScreen();
		
		Paint += new PaintEventHandler(OnPaint);
		timer1.Interval = 15;	
		timer1.Tick += new EventHandler(Ticker);
		timer1.Start();
		sprite.Start(90);
		
		//enabling double-buffering to avoid flicker
		SetStyle(ControlStyles.UserPaint, true);
		SetStyle(ControlStyles.AllPaintingInWmPaint, true);
		SetStyle(ControlStyles.DoubleBuffer, true);				
	}
	
	void Ticker(object sender, EventArgs e)
	{		
		if(x<Width)
			x+=3;
		else
			x=-100;		
		
		Invalidate();		
	}	
	
	void OnPaint(Object sender, PaintEventArgs e) 
	{
		Graphics g = e.Graphics;
		
		DrawStuff(g);			
	} 
	
	void DrawStuff(Graphics g)
	{					
		g.DrawImage(background, 0, 0);			
		g.DrawImage(sprite.Paint(g), x, 40);		
	}
		
	static void Main(string[] args)
	{
		Application.Run(new MainForm());
	}
}

//sprite class slightly modified after a sourcecode by David Sosby
 public class AnimSprite
 {
     private int frame, interval, width, height;
     private string imgFile;
     private Image img;
     private Timer frameTimer;

     public AnimSprite(string imgFile, int height)
     {
          this.height = height;
          this.imgFile = imgFile;
          img = new Bitmap(imgFile);
          width = img.Width;
     }

     public void Start(int interval)
     {
          this.interval = interval;
          frameTimer = new Timer();
          frameTimer.Interval = interval;
          frameTimer.Tick += new EventHandler(advanceFrame);
          frameTimer.Start();
     }     

     public void Stop()
     {
          frameTimer.Stop();
          frameTimer.Dispose();
     }

     public Bitmap Paint(Graphics e)
     {
          Bitmap temp;
          Graphics tempGraphics;

          temp = new Bitmap(width, height, e);
          tempGraphics = Graphics.FromImage(temp);

          tempGraphics.DrawImageUnscaled(img, 0, 0-(height*frame));

          tempGraphics.Dispose();
          return(temp);
     }

     private void advanceFrame(Object sender, EventArgs e)
     {
          frame++;
          if ( frame >= img.Height/height )
               frame = 0;
     }
}
